#include <algorithm>
#include <cstdio>
#include <set>
#include <vector>

const int mod1 = 2113929217, mod2 = 2013265921;
const int seed1 = 1e6 + 33, seed2 = 1e6 + 3;

using uint64 = unsigned long long;

int main() {
  int n;
  while (scanf("%d", &n) == 1) {
    std::vector<int> a(n);
    std::set<std::pair<uint64, uint64>> ret;
    for (int i = 0; i < n; ++i)
      scanf("%d", &a[i]);
    uint64 p1 = 1, p2 = 1;
    for (int i = 0; i < n; ++i) {
      p1 = p1 * seed1 % mod1;
      p2 = p2 * seed2 % mod2;
    }
    uint64 h1 = 0, h2 = 0;
    for (int i = 0; i < n; ++i) {
      h1 = (h1 * seed1 + a[i]) % mod1;
      h2 = (h2 * seed2 + a[i]) % mod2;
    }
    for (int i = 0; i < n; ++i) {
      ret.emplace(h1, h2);
      h1 = (h1 * seed1 + a[i]) % mod1;
      h2 = (h2 * seed2 + a[i]) % mod2;
      h1 = (h1 - a[i] * p1 % mod1 + mod1) % mod1;
      h2 = (h2 - a[i] * p2 % mod2 + mod2) % mod2;
    }
    std::reverse(a.begin(), a.end());
    h1 = 0, h2 = 0;
    for (int i = 0; i < n; ++i) {
      h1 = (h1 * seed1 + a[i]) % mod1;
      h2 = (h2 * seed2 + a[i]) % mod2;
    }
    for (int i = 0; i < n; ++i) {
      ret.emplace(h1, h2);
      h1 = (h1 * seed1 + a[i]) % mod1;
      h2 = (h2 * seed2 + a[i]) % mod2;
      h1 = (h1 - a[i] * p1 % mod1 + mod1) % mod1;
      h2 = (h2 - a[i] * p2 % mod2 + mod2) % mod2;
    }
    printf("%d\n", (int)ret.size());
  }
  return 0;
}
