#include <cstdint>
#include <cstdio>
#include <vector>

const int MOD = 1e9 + 7;

int inverse(int a) {
  return a == 1 ? 1 : (int64_t)(MOD - MOD / a) * inverse(MOD % a) % MOD;
}

int main() {
  int n, one;
  while (scanf("%d%d", &n, &one) == 2) {
    std::vector<int> a(n), b(n);
    for (int i = 0; i < n; ++i) {
      scanf("%d", &a[i]);
    }
    for (int i = 0; i < n; ++i) {
      scanf("%d", &b[i]);
    }
    if (one) {
      int one_inv = inverse(one);
      int det = 1;
      for (int _ = 0; _ < n; ++_) {
        det = (int64_t)det * one % MOD;
      }
      int sum = 1;
      for (int i = 0; i < n; ++i) {
        sum += (int64_t)a[i] * one_inv % MOD * b[i] % MOD;
        if (sum >= MOD) {
          sum -= MOD;
        }
      }
      printf("%d\n", (int)((int64_t)sum * det % MOD));
    } else {
      printf("%d\n", n > 1 ? 0 : (int)((int64_t)a[0] * b[0] % MOD));
    }
  }
}