#include <algorithm>
#include <cstdio>
#include <cstring>

using int64 = long long;

const int N = 2e5 + 10;

struct Node {
  int64 mx, tag;
  void apply(int64 v) { mx += v, tag += v; }
} T[N << 2];

int a[N], b[N];
int64 sum[N];

void build(int o, int l, int r) {
  T[o].tag = 0;
  if (l + 1 == r) {
    T[o].mx = a[l] - sum[l];
    return;
  }
  int m = (l + r) >> 1;
  build(o << 1, l, m);
  build(o << 1 | 1, m, r);
  T[o].mx = std::max(T[o << 1].mx, T[o << 1 | 1].mx);
}

void push(int o) {
  if (T[o].tag) {
    T[o << 1].apply(T[o].tag);
    T[o << 1 | 1].apply(T[o].tag);
    T[o].tag = 0;
  }
}

void add(int o, int l, int r, int L, int R, int64 v) {
  if (L <= l && R >= r) {
    T[o].apply(v);
    return;
  }
  push(o);
  int m = (l + r) >> 1;
  if (L < m)
    add(o << 1, l, m, L, R, v);
  if (R > m)
    add(o << 1 | 1, m, r, L, R, v);
  T[o].mx = std::max(T[o << 1].mx, T[o << 1 | 1].mx);
}

int main() {
  int n, m;
  while (scanf("%d%d", &n, &m) == 2) {
    for (int i = 1; i <= n; ++i)
      scanf("%d", &a[i]);
    for (int i = 1; i <= n; ++i)
      scanf("%d", &b[i]);
    for (int i = 1; i <= n; ++i)
      sum[i] = sum[i - 1] + b[i];
    build(1, 0, n);
    for (int i = 1; i <= n; ++i)
      sum[i] = 0;
    for (int i = 1; i <= n; ++i) {
      for (int x = i; x <= n; x += ~x & x + 1)
        sum[x] += b[i];
    }
    for (int i = 0; i < m; ++i) {
      int op, x, y;
      scanf("%d%d", &op, &x);
      if (op == 3) {
        int64 ret = a[x], s = 0;
        for (int y = x; y >= 0; y -= ~y & y + 1)
          s += sum[y];
        ret -= s;
        int l = 0, r = n, o = 1;
        while (l + 1 != r) {
          push(o);
          int m = (l + r) >> 1;
          if (x > m)
            ret = std::max(ret, T[o << 1].mx), o = o * 2 + 1, l = m;
          else
            o = o * 2, r = m;
        }
        ret = std::max(ret, T[o].mx);
        printf("%lld\n", ret + s);
      } else {
        scanf("%d", &y);
        if (op == 1) {
          int delta = y - a[x];
          if (x != n)
            add(1, 0, n, x, x + 1, delta);
          a[x] = y;
        } else {
          int delta = y - b[x];
          if (x != n)
            add(1, 0, n, x, n, -delta);
          b[x] = y;
          for (; x <= n; x += ~x & x + 1)
            sum[x] += delta;
        }
      }
    }
  }
  return 0;
}
