#include <cstdio>
#include <vector>

using i64 = long long;

const int mod = 1e9 + 7;
const int N = 1 << 21;

int sum[N][20];

i64 pow_mod(i64 a, i64 n) {
  i64 r = 1;
  for (; n; n >>= 1) {
    if (n & 1)
      r = r * a % mod;
    a = a * a % mod;
  }
  return r;
}

int main() {
  int n, m;
  while (scanf("%d%d", &n, &m) == 2) {
    std::vector<int> a(n);
    for (int i = 0; i < n; ++i) {
      scanf("%d", &a[i]);
      --a[i];
    }

    // #[x = 0 mod 2^w, i + 1 <= x <= 2^m - n + i]
    auto count = [&](int i, int w) -> i64 {
      if (w >= m)
        return 0;
      i64 ret = 0;
      if (w <= 20) {
        i64 pw = 1 << w;
        ret -= i / pw + (n - i) / pw;
        if ((n - i) % pw != 0) {
          ret -= 1;
        }
      } else {
        ret -= 1;
      }
      ret += pow_mod(2, m - w) + mod;
      return ret % mod;
    };

    // find sum
    i64 total = (pow_mod(2, m) - n + mod) * n % mod;
    for (int i = 0; i < n; ++i) {
      total -= count(i, a[i]) - count(i, a[i] + 1);
    }
    total = (total % mod + mod) % mod;

    // find min
    int ret = 0, s = 1, h = 0;
    for (; s <= n; ++h, s *= 2) {
    }

    for (int i = 0; i <= s * 4; ++i) {
      for (int j = 0; j <= h; ++j)
        sum[i][j] = 0;
    }
    for (int w = 1, offset = 0; w <= s; w *= 2) {
      for (int i = 0; i < n; ++i)
        if (a[i] <= h) {
          sum[offset + (i % w)][a[i]]++;
        }
      offset += w;
    }

    for (int x = 0; x < n; ++x) {            // center at x
      int o = 0, e = std::max(x, n - 1 - x); // center is o
      while (o < m && o < 20 && e > (1 << o) - 1)
        ++o;
      if (o == m)
        continue;
      int now = 0;
      for (int l = 0, offset = 0, w = 1; l < h; ++l, w *= 2) {
        now += sum[offset + (x % w)][l] - sum[offset + w + (x % (w * 2))][l];
        offset += w;
      }
      ret = std::max(ret, now + (a[x] >= o));
    }
    printf("%d %lld\n", n - ret, total);
  }
  return 0;
}
