#include <algorithm>
#include <cstdio>
#include <vector>

static const int MOD = 1e9 + 7;
static_assert((MOD + 1) % 3 == 0, "");
static const long long INV_3 = (MOD + 1) / 3;

void add(int &x, int a) {
  x += a;
  if (x >= MOD) {
    x -= MOD;
  }
}

int main() {
  int n, m;
  while (scanf("%d%d", &n, &m) == 2) {
    std::vector<int> left(n + 1, 0);
    for (int i = 0, l, r; i < m; ++i) {
      scanf("%d%d", &l, &r);
      left.at(r) = std::max(left.at(r), l);
    }
    std::vector<std::vector<int>> dp(n + 1, std::vector<int>(n + 1));
    std::vector<int> rsum(n + 1);
    int sum = dp.at(0).at(0) = rsum.at(0) = 1;
    for (int k = 1, deadline = 0; k <= n; ++k) {
      rsum.at(k) = dp.at(k).at(k) = INV_3 * sum % MOD;
      for (int j = deadline; j < k; ++j) {
        add(rsum.at(k), dp.at(k).at(j) = INV_3 * rsum.at(j) % MOD);
      }
      add(sum, rsum.at(k));
      while (deadline < left.at(k)) {
        for (int i = 0; i <= k; ++i) {
          int v = MOD - dp.at(i).at(deadline);
          add(rsum.at(i), v);
          add(sum, v);
        }
        deadline++;
      }
    }
    for (int i = 0; i < n; ++i) {
      sum = 6LL * sum % MOD;
    }
    printf("%d\n", sum);
  }
}
